#
# Name:
#   diagnose_data.rb  
#
# Created by: mansson
#
# Description:
#   
#
#
# Copyright (c) 2013 Recorded Future
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

require 'mixlib/shellout'

class DiagnoseData

  def self.get_all_diag_info
    diagnose_data ={}
    diagnose_data['resolvconf'] = get_file_data('/etc/resolv.conf')
    diagnose_data['ifconfig'] = get_cmd_output('ifconfig')
    diagnose_data
  end

  def self.get_file_data(file_name)
    begin
      file_data = {:file_name => file_name}
      data_file = File.open(file_name,'r')
      file_data[:file_content] = data_file.read
      data_file.close
      file_data[:file_time_stamp] = File.mtime(file_name)
    rescue Exception => e
      file_data['error'] = e.inspect
    end
    file_data
  end

  def self.get_cmd_output(cmd)
    cmd_data = {:cmd => cmd}
    cmd = Mixlib::ShellOut.new(cmd)
    cmd.run_command
    if cmd.error?
      cmd_data[:error] = cmd.stderr
    else
      cmd_data[:result] = cmd.stdout
    end
    cmd_data
  end

end