#
# Name:
#   log_data.rb  
#
# Created by: GaddyGaddy
#
# Description:
#   Will get log_data from a log file
#
#
# Copyright (c) 2013 GaddyGaddy
#
# All rights reserved.
# 

VALID_FILE_NAMES = ['log','resolv']

class LogData

  #
  # Get a specific number of lines from  a log file
  #
  def self.get_log_data(log_file_name, lines)
    unless log_file_name.index('/')
      log_file_name = log_file_name + '.log' unless log_file_name[-4..-1] == '.log'
      log_file_name = "/opt/log/#{log_file_name[0..-5]}/#{log_file_name}"
    end
    raise "File #{log_file_name} does not exist" unless File.exist?(log_file_name)
    raise "File name must have log" if VALID_FILE_NAMES.select{|f| log_file_name.index f}.empty?
    cmd = "tail -n #{lines} #{log_file_name}"
    exit_code, stdout = systemu cmd
    if exit_code.success?
      stdout
    else
      'Could not read log_data from ' + log_file_name
    end
  end

  #
  # Get the time when the log file was last modified
  #
  def self.get_log_file_time(log_file_name)
    File.mtime(log_file_name).to_s
  end
end