#
# Name:
#   requests.rb  
#
# Created by: GaddyGaddy
#
# Description:
#   
#
#
# Copyright (c) 2013 GaddyGaddy
#
# All rights reserved.
#
require 'cgi'

require_relative '../utils/retriable'
require_relative '../logging/logging'
class Request
  extend Logging
  extend  Retriable

  # Get a base url for accessing the client service
  # TODO Change this to https but we need a certificate for that
  def self.get_base_url(host)
    url = host
    url = "http://" + url unless url[0..3] == "http"
    url
  end


  #
  # Will do a request
  # path will be evaluated so there could be parameters in that one and then use ''  for the string
  # to have the parameters evaluated in this function
  #
  def self.client_service_get(host, path, retries = 1)
    url = get_base_url(host) + path
    logger.debug "Will request url #{url}"
    result = with_retries(:limit => retries, :sleep=> 5) { RestClient.get url }
    result_json = JSON.parse(result)
    logger.debug "The result of the request is #{result.inspect}"
    result_json
  end

  def self.client_service_post(url, param, retries = 1)
    logger.debug "Will request url #{url}"
    result = with_retries(:limit => retries, :sleep=> 5) { RestClient.post url, param }
    JSON.parse(result)
  end

end
